kiss/kiss

1131 lines
37 KiB
Plaintext
Raw Normal View History

#!/bin/sh -ef
#
2019-08-19 17:07:50 +00:00
# This is a simple package manager written in POSIX 'sh' for
# KISS Linux, utilizing the core UNIX utilities where needed.
#
# Disable warnings against word-splitting and globbing.
# They are used *safely* throughout this script as globbing
# is globally disabled and assumptions can be made about the input.
# shellcheck disable=2046,2086
2019-06-13 14:48:08 +00:00
#
2019-06-29 20:38:35 +00:00
# The script runs with 'set -e' enabled. It will exit on any
# non-zero return code. This ensures that no function continues
# if it fails at any point.
#
# Keep in mind that this involves extra code in the case where
2019-07-13 22:24:56 +00:00
# an error is optional and/or required.
2019-06-29 20:38:35 +00:00
#
2019-07-13 22:24:56 +00:00
# Where possible the package manager should check things first,
# die if necessary and continue if all is well.
2019-06-29 20:38:35 +00:00
#
# The code below conforms to shellcheck's rules. However, some
# lint errors *are* disabled as they relate to unexpected
# behavior (which we do expect).
#
# KISS is available under the MIT license.
#
# - Dylan Araps.
2019-06-13 14:48:08 +00:00
die() {
2019-06-28 21:26:43 +00:00
# Print a message and exit with '1' (error).
2019-08-19 17:15:50 +00:00
printf '\033[1;31m!>\033[m %s.\n' "$@" >&2
2019-06-13 14:48:08 +00:00
exit 1
}
log() {
2019-08-19 17:07:13 +00:00
# Print a message prettily.
2019-08-19 17:15:50 +00:00
printf '\033[1;32m=>\033[m %s.\n' "$@"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_lint() {
# Check that each mandatory file in the package entry exists.
2019-08-19 18:02:18 +00:00
log "[$1] Checking repository files"
2019-06-13 14:48:08 +00:00
2019-08-19 17:06:31 +00:00
# Figure out *where* the repository entry for the package is located.
2019-07-03 14:31:00 +00:00
repo_dir=$(pkg_search "$1")
2019-06-29 20:38:35 +00:00
2019-07-03 14:31:00 +00:00
cd "$repo_dir" || die "'$repo_dir' not accessible"
2019-08-19 18:02:18 +00:00
[ -f sources ] || die "[$1] Sources file not found"
[ -x build ] || die "[$1] Build file not found or not executable"
[ -s version ] || die "[$1] Version file not found or empty"
2019-06-29 20:38:35 +00:00
# Ensure that the release field in the version file is set
2019-07-13 21:25:36 +00:00
# to something. The above test checks for the version field inclusively.
2019-08-19 17:05:48 +00:00
read -r _ release < version
2019-08-19 17:15:50 +00:00
[ "$release" ] || die "Release field not found in version file"
2019-06-18 08:05:15 +00:00
}
2019-06-13 16:40:50 +00:00
pkg_search() {
2019-06-28 21:26:43 +00:00
# Figure out which repository a package belongs to by
# searching for directories matching the package name
2019-06-29 20:38:35 +00:00
# in $KISS_PATH/*.
[ "$KISS_PATH" ] || \
2019-08-19 17:15:50 +00:00
die "\$KISS_PATH needs to be set" \
2019-08-19 17:23:33 +00:00
"Example: 'KISS_PATH=/var/db/kiss/repo/core:/var/db/kiss/repo/extra'" \
"Repositories will be searched in the configured order" \
"The variable should work just like \$PATH"
2019-06-28 21:26:43 +00:00
# Find the repository containing a package.
# Searches installed packages if the package is absent from the repositories.
set -- "$1" $(IFS=:; find $KISS_PATH "$KISS_ROOT/$pkg_db" \
-maxdepth 1 -name "$1")
2019-06-13 16:40:50 +00:00
2019-06-29 20:38:35 +00:00
# A package may also not be found due to a repository not being
# readable by the current user. Either way, we need to die here.
2019-08-19 17:15:50 +00:00
[ -z "$2" ] && die "Package '$1' not in any repository"
2019-06-13 16:40:50 +00:00
2019-06-28 21:26:43 +00:00
printf '%s\n' "$2"
2019-06-13 16:40:50 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_list() {
# List installed packages. As the format is files and
# directories, this just involves a simple for loop and
2019-06-29 20:38:35 +00:00
# file read.
# Change directories to the database. This allows us to
# avoid having to 'basename' each path. If this fails,
2019-06-29 20:38:35 +00:00
# set '$1' to mimic a failed glob which indicates that
# nothing is installed.
2019-07-19 22:14:46 +00:00
cd "$KISS_ROOT/$pkg_db" 2>/dev/null ||
set -- "$KISS_ROOT/$pkg_db/"\*
2019-06-29 20:38:35 +00:00
# Optional arguments can be passed to check for specific
# packages. If no arguments are passed, list all. As we
# loop over '$@', if there aren't any arguments we can
# just set the directory contents to the argument list.
[ "$1" ] || { set +f; set -f -- *; }
2019-06-29 20:38:35 +00:00
# If the 'glob' above failed, exit early as there are no
# packages installed.
2019-07-19 22:14:46 +00:00
[ "$1" = "$KISS_ROOT/$pkg_db/"\* ] && return 1
2019-06-29 20:38:35 +00:00
# Loop over each version file and warn if one doesn't exist.
# Also warn if a package is missing its version file.
for pkg; do
[ -d "$pkg" ] || {
2019-08-19 17:15:50 +00:00
log "Package '$pkg' is not installed"
2019-06-29 20:38:35 +00:00
return 1
}
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
[ -f "$pkg/version" ] || {
2019-08-19 18:09:43 +00:00
log "[$pkg] Warning, package has no version file"
continue
2019-06-15 06:19:20 +00:00
}
2019-06-29 20:38:35 +00:00
read -r version release < "$pkg/version" &&
printf '%s\n' "$pkg $version-$release"
done
2019-06-13 14:48:08 +00:00
}
pkg_sources() {
2019-06-29 20:38:35 +00:00
# Download any remote package sources. The existence of local
# files is also checked.
2019-08-19 18:02:18 +00:00
log "[$1] Downloading sources"
2019-06-29 20:38:35 +00:00
# Store each downloaded source in named after the package it
# belongs to. This avoid conflicts between two packages having a
# source of the same name.
mkdir -p "$src_dir/$1"
cd "$src_dir/$1"
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
2019-06-13 14:48:08 +00:00
while read -r src _; do
2019-06-29 20:38:35 +00:00
case $src in
# Git repository.
git:*)
git clone "${src##git:}" "$mak_dir"
;;
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
# Remote source.
*://*)
[ -f "${src##*/}" ] && {
2019-08-19 18:02:18 +00:00
log "[$1] Found cached source '${src##*/}'"
2019-06-29 20:38:35 +00:00
continue
}
wget "$src" || {
rm -f "${src##*/}"
2019-08-19 18:02:18 +00:00
die "[$1] Failed to download $src"
2019-06-29 20:38:35 +00:00
}
;;
2019-06-13 14:48:08 +00:00
2019-08-19 18:09:43 +00:00
# Local files (sources that are non-remote are assumed to be local).
2019-06-29 20:38:35 +00:00
*)
2019-08-19 18:09:43 +00:00
[ -f "$repo_dir/$src" ] || die "[$1] No local file '$src'"
2019-06-18 18:39:40 +00:00
2019-08-19 18:02:18 +00:00
log "[$1] Found local file '$src'"
2019-06-29 20:38:35 +00:00
;;
esac
done < "$repo_dir/sources"
2019-06-13 14:48:08 +00:00
}
pkg_extract() {
# Extract all source archives to the build directory and copy over
2019-06-29 20:38:35 +00:00
# any local repository files.
2019-08-19 18:02:18 +00:00
log "[$1] Extracting sources"
2019-06-29 20:38:35 +00:00
# Store each downloaded source in named after the package it
# belongs to. This avoid conflicts between two packages having a
# source of the same name.
mkdir -p "$mak_dir/$1" && cd "$mak_dir/$1"
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
while read -r src dest; do
mkdir -p "./$dest"
case $src in
# Do nothing as git repository was downloaded to the build
# directory directly.
2019-06-29 20:38:35 +00:00
git:*) ;;
# Only 'tar' archives are currently supported for extraction.
# Any other file-types are simply copied to '$mak_dir' which
2019-06-29 20:38:35 +00:00
# allows you to extract them manually.
*://*.tar*|*://*.tgz)
tar xf "$src_dir/$1/${src##*/}" -C "./$dest" \
--strip-components 1 \
2019-08-19 18:02:18 +00:00
|| die "[$1] Couldn't extract ${src##*/}"
2019-06-29 20:38:35 +00:00
;;
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
# Local files (Any source that is non-remote is assumed to be local).
*)
if [ -f "$repo_dir/$src" ]; then
cp -f "$repo_dir/$src" "./$dest"
2019-07-04 06:13:44 +00:00
elif [ -f "$src_dir/$1/${src##*/}" ]; then
cp -f "$src_dir/$1/${src##*/}" "./$dest"
else
2019-08-19 18:02:18 +00:00
die "[$1] Local file $src not found"
fi
2019-06-29 20:38:35 +00:00
;;
2019-06-13 14:48:08 +00:00
esac
2019-06-29 20:38:35 +00:00
done < "$repo_dir/sources"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_depends() {
# Resolve all dependencies and install them in the right order.
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
# This does a depth-first search. The deepest dependencies are
# listed first and then the parents in reverse order.
case $missing_deps in
# Dependency is already in list, skip it.
*" $1 "*) ;;
*)
# Recurse through the dependencies of the child
# packages. Keep doing this.
[ -f "$repo_dir/depends" ] &&
while read -r dep _; do
2019-07-15 07:23:26 +00:00
[ "${dep##\#*}" ] || continue
pkg_depends "$dep" ||:
done < "$repo_dir/depends"
# After child dependencies are added to the list,
# add the package which depends on them.
missing_deps="$missing_deps $1 "
;;
esac
2019-06-29 20:38:35 +00:00
}
pkg_verify() {
# Verify all package checksums. This is achieved by generating
# a new set of checksums and then comparing those with the old
# set.
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
# Generate a second set of checksums to compare against the
# repository's checksums for the package.
2019-07-21 11:21:47 +00:00
pkg_checksums "$1" > "$cac_dir/c-$1"
2019-06-29 20:38:35 +00:00
# Compare the checksums using 'cmp'.
2019-07-21 11:21:47 +00:00
cmp -s "$cac_dir/c-$1" "$repo_dir/checksums" || {
2019-08-19 18:02:18 +00:00
log "[$1] Checksum mismatch"
2019-06-29 20:38:35 +00:00
# Instead of dying above, log it to the terminal. Also define a
# variable so we *can* die after all checksum files have been
# checked.
mismatch="$mismatch$1 "
}
2019-06-13 14:48:08 +00:00
}
pkg_strip() {
2019-06-29 20:38:35 +00:00
# Strip package binaries and libraries. This saves space on the
# system as well as on the tar-balls we ship for installation.
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
# Package has stripping disabled, stop here.
[ -f "$repo_dir/nostrip" ] && return
2019-06-13 14:48:08 +00:00
2019-08-19 18:02:18 +00:00
log "[$1] Stripping binaries and libraries"
2019-06-29 20:38:35 +00:00
2019-07-13 22:23:22 +00:00
# Strip only files matching the below mime-types from the package
# directory. No alternative to 'file' here sadly.
2019-06-29 20:38:35 +00:00
find "$pkg_dir/$1" -type f | while read -r binary; do
2019-06-13 14:48:08 +00:00
case $(file -bi "$binary") in
application/x-sharedlib*|application/x-pie-executable*)
strip_opts=--strip-unneeded
;;
application/x-archive*) strip_opts=--strip-debug ;;
application/x-executable*) strip_opts=--strip-all ;;
*) continue ;;
esac
2019-06-29 20:38:35 +00:00
# Suppress errors here as some binaries and libraries may
# fail to strip. This is OK.
strip "$strip_opts" "$binary" 2>/dev/null ||:
2019-06-13 14:48:08 +00:00
done
}
pkg_fixdeps() {
# Dynamically look for missing runtime dependencies by checking
# each binary and library with 'ldd'. This catches any extra
# libraries and or dependencies pulled in by the package's
# build suite.
# Store the package name in a variable as the code below
# redefines the argument list.
pkg_name=$1
2019-08-19 18:02:18 +00:00
log "[$1] Checking 'ldd' for missing dependencies"
# Go to the directory containing the built package to
# simplify path building.
cd "$pkg_dir/$1/$pkg_db/$1"
# Generate a list of binaries and libraries, false files
# will be found however it's faster to get 'ldd' to check
# them anyway than to filter them out.
set -- $(find "$pkg_dir/$1/usr/bin/" \
"$pkg_dir/$1/usr/lib/" -type f 2>/dev/null)
# Make a copy of the depends file if it exists to have a
# reference to 'diff' against.
[ -f depends ] && cp -f depends depends-copy
for file; do
# Run 'ldd' on the file and parse each line. The code
# then checks to see which packages own the linked
# libraries and it prints the result.
ldd "$file" 2>/dev/null | while read -r dep; do
# Skip lines containing 'ldd'.
[ "${dep##*ldd*}" ] || continue
# Extract the file path from 'ldd' output.
dep=${dep#* => }
dep=${dep% *}
# Traverse symlinks to get the true path to the file.
dep=$(readlink -f "$KISS_ROOT/${dep##$KISS_ROOT}")
# Figure out which package owns the file.
dep=$(set +f; grep -lFx "${dep##$KISS_ROOT}" \
"$KISS_ROOT/$pkg_db/"*/manifest)
# Extract package name from 'grep' match.
dep=${dep%/*}
dep=${dep##*/}
case $dep in
# Skip listing these packages as dependencies.
musl|gcc|$pkg_name) ;;
*) printf '%s\n' "$dep" ;;
esac
done ||:
done >> depends-copy
# Remove duplicate entries from the new depends file.
# This remove duplicate lines looking *only* at the
# first column.
sort -u -k1,1 depends-copy > depends-new
# Display a 'diff' of the new dependencies agaisnt
# the old ones. '-N' treats non-existent files as blank.
diff -N depends depends-new ||:
# Do some clean up as this required a few temporary files.
mv -f depends-new depends
rm -f .depends
}
2019-06-29 20:38:35 +00:00
pkg_manifest() (
# Generate the package's manifest file. This is a list of each file
# and directory inside the package. The file is used when uninstalling
# packages, checking for package conflicts and for general debugging.
2019-08-19 18:02:18 +00:00
log "[$1] Generating manifest"
2019-06-30 08:35:54 +00:00
# This funcion runs as a sub-shell to avoid having to 'cd' back to the
2019-06-29 20:38:35 +00:00
# prior directory before being able to continue.
cd "$pkg_dir/$1"
# Find all files and directories in the package. Directories are printed
# with a trailing forward slash '/'. The list is then reversed with
# directories appearing *after* their contents.
find . -mindepth 1 -type d -exec printf '%s/\n' {} + -or -print |
2019-07-19 22:14:46 +00:00
sort -r | sed -e ss.ss > "$pkg_dir/$1/$pkg_db/$1/manifest"
2019-06-29 20:38:35 +00:00
)
2019-06-13 14:48:08 +00:00
pkg_tar() {
# Create a tar-ball from the built package's files.
# This tar-ball also contains the package's database entry.
2019-08-19 18:02:18 +00:00
log "[$1] Creating tar-ball"
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
# Read the version information to name the package.
read -r version release < "$repo_dir/version"
# Create a tar-ball from the contents of the built package. `fakeroot`
# is used here to correct issues with file ownership.
fakeroot \
tar zpcf "$bin_dir/$1#$version-$release.tar.gz" -C "$pkg_dir/$1" . ||
2019-08-19 18:02:18 +00:00
die "[$1] Failed to create tar-ball"
2019-06-29 20:38:35 +00:00
2019-08-19 18:02:18 +00:00
log "[$1] Successfully created tar-ball"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_build() {
# Build packages and turn them into packaged tar-balls. This function
2019-06-29 20:38:35 +00:00
# also checks checksums, downloads sources and ensure all dependencies
# are installed.
2019-06-17 07:18:36 +00:00
2019-08-19 17:15:50 +00:00
log "Resolving dependencies"
for pkg; do pkg_depends "$pkg"; done
2019-06-29 20:38:35 +00:00
# Store the explicit packages so we can handle them differently
# below. Dependencies are automatically installed but packages
# passed to KISS aren't.
explicit_packages=" $* "
# Set the resolved dependency list as the function's arguments.
set -- $missing_deps
2019-07-11 06:14:17 +00:00
2019-07-13 22:23:22 +00:00
# The dependency solver always lists all dependencies regardless of
# whether or not they are installed. Ensure that all explicit packages
# are included and ensure that all installed packages are excluded.
for pkg; do
case $explicit_packages in
*" $pkg "*)
build_packages="$build_packages$pkg "
;;
*)
pkg_list "$pkg" >/dev/null ||
build_packages="$build_packages$pkg "
;;
esac
done
# Set the filtered dependency list as the function's arguments.
set -- $build_packages
2019-08-19 17:15:50 +00:00
log "Building: $*"
2019-07-11 06:14:17 +00:00
# Only ask for confirmation if more than one package needs to be built.
2019-07-13 22:18:07 +00:00
[ $# -gt 1 ] || [ "$build_prompt" ] && {
2019-08-19 17:15:50 +00:00
log "Continue?: Press Enter to continue or Ctrl+C to abort here"
# POSIX 'read' has none of the "nice" options like '-n', '-p'
# etc etc. This is the most basic usage of 'read'.
read -r REPLY || exit
}
2019-07-11 06:14:17 +00:00
2019-08-19 17:15:50 +00:00
log "Checking to see if any dependencies have already been built"
log "Installing any pre-built dependencies"
# Install any pre-built dependencies if they exist in the binary
# directory and are up to date.
for pkg; do
2019-08-15 15:28:46 +00:00
# Don't check for a pre-built package if it was passed to KISS
# directly.
2019-06-30 06:47:38 +00:00
case $explicit_packages in
*" $pkg "*)
shift
set -- "$@" "$pkg"
continue
;;
esac
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$pkg")
# Figure out the version and release.
read -r version release < "$repo_dir/version"
# Remove the current package from the package list.
shift
# Install any pre-built binaries if they exist.
2019-08-12 23:57:31 +00:00
# This calls 'args' to inherit a root check and call
# to 'sudo' to elevate permissions.
[ -f "$bin_dir/$pkg#$version-$release.tar.gz" ] && {
2019-08-19 18:02:18 +00:00
log "[$pkg] Found pre-built binary, installing"
2019-08-12 23:57:31 +00:00
args i "$bin_dir/$pkg#$version-$release.tar.gz"
continue
}
# Add the removed package back to the list if it doesn't
# have a pre-built binary.
2019-06-30 07:39:38 +00:00
set -- "$@" "$pkg"
done
2019-06-29 20:38:35 +00:00
for pkg; do pkg_lint "$pkg"; done
2019-07-03 14:29:57 +00:00
for pkg; do
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$pkg")
# Ensure that checksums exist prior to building the package.
[ -f "$repo_dir/checksums" ] || {
2019-08-19 18:02:18 +00:00
log "[$pkg] Checksums are missing"
2019-07-03 14:29:57 +00:00
# Instead of dying above, log it to the terminal. Also define a
# variable so we *can* die after all checksum files have been
# checked.
no_checkums="$no_checkums$pkg "
}
done
# Die here as packages without checksums were found above.
[ "$no_checkums" ] &&
2019-08-19 17:15:50 +00:00
die "Run 'kiss checksum ${no_checkums% }' to generate checksums"
2019-07-03 14:29:57 +00:00
2019-06-29 20:38:35 +00:00
for pkg; do pkg_sources "$pkg"; done
for pkg; do pkg_verify "$pkg"; done
2019-06-17 07:18:36 +00:00
2019-06-29 20:38:35 +00:00
# Die here as packages with differing checksums were found above.
[ "$mismatch" ] &&
die "Checksum mismatch with: ${mismatch% }"
2019-06-13 14:48:08 +00:00
2019-07-03 13:35:14 +00:00
# Finally build and create tarballs for all passed packages and
# dependencies.
2019-06-29 20:38:35 +00:00
for pkg; do
2019-06-30 06:47:38 +00:00
pkg_extract "$pkg"
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$pkg")
2019-06-17 07:18:36 +00:00
2019-06-29 20:38:35 +00:00
# Install built packages to a directory under the package name
# to avoid collisions with other packages.
2019-07-19 22:14:46 +00:00
mkdir -p "$pkg_dir/$pkg/$pkg_db"
2019-06-26 16:27:36 +00:00
2019-06-29 20:38:35 +00:00
# Move to the build directory and call the build script.
2019-08-18 17:30:57 +00:00
cd "$mak_dir/$pkg"
fakeroot "$repo_dir/build" "$pkg_dir/$pkg" ||
2019-08-19 18:02:18 +00:00
die "[$pkg] Build failed"
2019-06-29 20:38:35 +00:00
# Copy the repository files to the package directory.
# This acts as the database entry.
2019-07-19 22:14:46 +00:00
cp -Rf "$repo_dir" "$pkg_dir/$pkg/$pkg_db/"
2019-06-29 20:38:35 +00:00
2019-08-19 18:02:18 +00:00
log "[$pkg] Successfully built package"
2019-06-29 20:38:35 +00:00
# Create the manifest file early and make it empty.
# This ensure that the manifest is added to the manifest...
2019-07-19 22:14:46 +00:00
: > "$pkg_dir/$pkg/$pkg_db/$pkg/manifest"
2019-06-26 16:27:36 +00:00
pkg_strip "$pkg"
pkg_fixdeps "$pkg"
pkg_manifest "$pkg"
pkg_tar "$pkg"
2019-06-26 16:27:36 +00:00
# Install only dependencies of passed packages.
case $explicit_packages in
*" $pkg "*) continue ;;
*) pkg_install "$pkg" ;;
esac
done
2019-06-29 20:38:35 +00:00
2019-08-19 17:15:50 +00:00
log "Successfully built package(s)"
# Turn the explicit packages into a 'list'.
set -- $explicit_packages
# Only ask for confirmation if more than one package needs to be installed.
[ $# -gt 1 ] && {
log "Install built packages? [$*]" \
2019-08-19 17:15:50 +00:00
"Press Enter to continue or Ctrl+C to abort here"
# POSIX 'read' has none of the "nice" options like '-n', '-p'
# etc etc. This is the most basic usage of 'read'.
read -r REPLY && {
args i "$@"
return
}
}
2019-08-19 17:15:50 +00:00
log "Run 'kiss i $*' to install the built package(s)"
2019-06-29 20:38:35 +00:00
}
pkg_checksums() {
# Generate checksums for packages.
2019-07-21 11:21:47 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$1")
2019-06-29 20:38:35 +00:00
2019-07-21 11:21:47 +00:00
while read -r src _; do
case $src in
# Git repository.
# Skip checksums on git repositories.
git:*) ;;
*)
# File is local to the package and is stored in the
# repository.
[ -f "$repo_dir/$src" ] &&
src_path=$repo_dir/${src%/*}
# File is remote and was downloaded.
[ -f "$src_dir/$1/${src##*/}" ] &&
src_path=$src_dir/$1
# Die here if source for some reason, doesn't exist.
[ "$src_path" ] ||
2019-08-19 18:02:18 +00:00
die "[$1] Couldn't find source '$src'"
2019-07-21 11:21:47 +00:00
# An easy way to get 'sha256sum' to print with the 'basename'
# of files is to 'cd' to the file's directory beforehand.
(cd "$src_path" && sha256sum "${src##*/}") ||
2019-08-19 18:02:18 +00:00
die "[$1] Failed to generate checksums"
2019-07-21 11:21:47 +00:00
# Unset this variable so it isn't used again on a failed
# source. There's no 'local' keyword in POSIX sh.
src_path=
;;
esac
done < "$repo_dir/sources"
2019-06-29 20:38:35 +00:00
}
pkg_conflicts() {
# Check to see if a package conflicts with another.
# This function takes a path to a KISS tar-ball as an argument.
2019-08-19 18:02:18 +00:00
log "[$2] Checking for package conflicts"
2019-06-29 20:38:35 +00:00
# Extract manifest from the tar-ball and only extract files entries.
2019-07-19 22:14:46 +00:00
tar xf "$1" -O "./$pkg_db/$2/manifest" |
2019-06-29 20:38:35 +00:00
while read -r line; do
[ "${line%%*/}" ] && printf '%s\n' "$line" >> "$cac_dir/manifest-$pid"
done ||:
# Enable globbing.
set +f
2019-06-29 20:38:35 +00:00
# Compare extracted manifest to all installed manifests.
# If there are matching lines (files) there is a package conflict.
2019-07-19 22:14:46 +00:00
for db in "$KISS_ROOT/$pkg_db/"*; do
2019-06-30 07:39:38 +00:00
[ "$2" = "${db##*/}" ] && continue
2019-06-26 16:27:36 +00:00
2019-06-29 20:38:35 +00:00
grep -Fxf "$cac_dir/manifest-$pid" "$db/manifest" 2>/dev/null &&
2019-08-19 17:15:50 +00:00
die "Package '$2' conflicts with '${db##*/}'"
2019-06-29 20:38:35 +00:00
done
2019-06-13 14:48:08 +00:00
# Disable globbing.
set -f
2019-06-29 20:38:35 +00:00
# Remove this temporary file as we no longer need it.
rm -f "$cac_dir/manifest-$pid"
2019-06-13 14:48:08 +00:00
}
pkg_remove() {
2019-06-29 20:38:35 +00:00
# Remove a package and all of its files. The '/etc' directory
# is handled differently and configuration files are *not*
# overwritten.
2019-06-13 14:48:08 +00:00
# The package is not installed, don't do anything.
pkg_list "$1" >/dev/null || {
2019-08-19 18:02:18 +00:00
log "[$1] Not installed"
return
}
# Enable globbing.
set +f
# Make sure that nothing depends on this package.
2019-07-19 22:14:46 +00:00
[ "$2" = check ] && for file in "$KISS_ROOT/$pkg_db/"*; do
# Check each depends file for the package and if it's
# a run-time dependency, append to the $required_by string.
grep -qFx "$1" "$file/depends" 2>/dev/null &&
2019-07-04 14:43:10 +00:00
required_by="$required_by'${file##*/}', "
done
2019-06-13 14:48:08 +00:00
# Disable globbing.
set -f
[ "$required_by" ] &&
2019-08-19 18:02:18 +00:00
die "[$1] Package is required by ${required_by%, }" \
"[$1] Aborting here..."
2019-07-26 16:21:44 +00:00
# Block being able to abort the script with 'Ctrl+C' during removal.
# Removes all risk of the user aborting a package removal leaving
2019-07-04 15:32:53 +00:00
# an incomplete package installed.
trap '' INT
while read -r file; do
# The file is in '/etc' skip it. This prevents the package
# manager from removing user edited configuration files.
[ "${file##/etc/*}" ] || continue
2019-06-26 16:27:36 +00:00
if [ -d "$KISS_ROOT/$file" ]; then
2019-07-21 08:14:34 +00:00
rmdir "$KISS_ROOT/$file" 2>/dev/null || continue
else
2019-07-21 08:14:34 +00:00
rm -f -- "$KISS_ROOT/$file" ||
2019-08-19 18:02:18 +00:00
log "[$1] Failed to remove '$file'"
fi
2019-07-19 22:14:46 +00:00
done < "$KISS_ROOT/$pkg_db/$1/manifest"
2019-07-26 16:21:44 +00:00
# Reset 'trap' to its original value. Removal is done so
2019-07-04 15:32:53 +00:00
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-08-19 18:02:18 +00:00
log "[$1] Removed successfully"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_install() {
# Install a built package tar-ball.
2019-06-14 05:58:09 +00:00
2019-06-29 20:38:35 +00:00
for pkg; do
# Install can also take the full path to a tar-ball.
2019-06-29 20:38:35 +00:00
# We don't need to check the repository if this is the case.
2019-06-30 07:39:38 +00:00
if [ -f "$pkg" ] && [ -z "${pkg%%*.tar.gz}" ] ; then
2019-06-29 20:38:35 +00:00
tar_file=$pkg
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
else
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "$pkg")
# Read the version information to name the package.
read -r version release < "$repo_dir/version"
# Construct the name of the package tarball.
tar_name=$pkg\#$version-$release.tar.gz
[ -f "$bin_dir/$tar_name" ] ||
2019-08-19 17:15:50 +00:00
die "Package '$pkg' has not been built" \
"Run 'kiss build $pkg'"
2019-06-29 20:38:35 +00:00
tar_file=$bin_dir/$tar_name
fi
# Figure out which package the tar-ball installs by checking for
# a database entry inside the tar-ball. If no database entry exists,
# exit here as the tar-ball is *most likely* not a KISS package.
2019-07-19 22:14:46 +00:00
pkg_name=$(tar tf "$tar_file" | grep -x "\./$pkg_db/.*/version") ||
2019-08-19 17:15:50 +00:00
die "'${tar_file##*/}' is not a valid KISS package"
2019-07-03 13:35:14 +00:00
pkg_name=${pkg_name%/*}
pkg_name=${pkg_name##*/}
2019-06-29 20:38:35 +00:00
2019-06-30 07:39:38 +00:00
pkg_conflicts "$tar_file" "$pkg_name"
2019-06-29 20:38:35 +00:00
2019-07-22 16:01:31 +00:00
mkdir -p "$tar_dir/$pkg_name"
2019-07-21 08:14:34 +00:00
# Extract the tar-ball to catch any errors before installation begins.
2019-07-22 16:01:31 +00:00
tar pxf "$tar_file" -C "$tar_dir/$pkg_name" ||
2019-08-19 18:02:18 +00:00
die "[$pkg_name] Failed to extract tar-ball"
2019-06-29 20:38:35 +00:00
2019-08-19 18:02:18 +00:00
log "[$pkg_name] Checking that all dependencies are installed"
2019-07-04 14:43:10 +00:00
# Make sure that all run-time dependencies are installed prior to
# installing the package.
2019-07-22 16:01:31 +00:00
[ -f "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends" ] &&
2019-07-04 14:43:10 +00:00
while read -r dep dep_type; do
2019-07-15 07:23:26 +00:00
[ "${dep##\#*}" ] || continue
[ "$dep_type" ] || pkg_list "$dep" >/dev/null ||
2019-07-04 14:43:10 +00:00
required_install="$required_install'$dep', "
2019-07-22 16:01:31 +00:00
done < "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends"
2019-07-04 14:43:10 +00:00
[ "$required_install" ] &&
2019-08-19 18:02:18 +00:00
die "[$1] Package requires ${required_install%, }" \
2019-08-19 17:15:50 +00:00
"[$1]: Aborting here"
2019-07-04 14:43:10 +00:00
2019-08-19 18:02:18 +00:00
log "[$pkg_name] Installing package"
2019-07-05 06:34:06 +00:00
# Block being able to abort the script with 'Ctrl+C' during installation.
# Removes all risk of the user aborting a package installation leaving
# an incomplete package installed.
trap '' INT
2019-07-21 08:14:34 +00:00
# If the package is already installed (and this is an upgrade) make a
# backup of the manifest file.
[ -f "$KISS_ROOT/$pkg_db/$pkg_name/manifest" ] &&
cp -f "$KISS_ROOT/$pkg_db/$pkg_name/manifest" "$cac_dir/m-$pkg_name"
2019-07-22 16:01:31 +00:00
# This is repeated multiple times. Better to make it a function.
rsync_pkg() {
rsync -HKav --exclude etc -- "$tar_dir/$pkg_name/" "$KISS_ROOT/"
}
2019-07-22 08:14:05 +00:00
2019-07-21 08:35:25 +00:00
# Install the package by using 'rsync' and overwrite any existing files
# (excluding '/etc/').
2019-07-22 16:01:31 +00:00
rsync_pkg
2019-07-21 08:14:34 +00:00
2019-07-21 08:35:25 +00:00
# If '/etc/' exists in the package, install it but don't overwrite.
2019-07-22 16:01:31 +00:00
[ -d "$tar_dir/$pkg_name/etc" ] &&
rsync -HKav --ignore-existing "$tar_dir/$pkg_name/etc" "$KISS_ROOT/"
2019-07-21 08:14:34 +00:00
# Remove any leftover files if this is an upgrade.
2019-07-22 16:01:31 +00:00
[ -f "$cac_dir/m-$pkg_name" ] && {
2019-07-21 08:14:34 +00:00
awk 'NR==FNR{lines[$0];next}!($0 in lines)' \
"$KISS_ROOT/$pkg_db/$pkg_name/manifest" "$cac_dir/m-$pkg_name" |
while read -r file; do
2019-07-22 16:01:31 +00:00
# Skip deleting some leftover files.
2019-07-22 20:49:43 +00:00
[ -f "$KISS_ROOT/$file" ] && [ ! -L "$KISS_ROOT/$file" ] &&
2019-07-22 16:01:31 +00:00
case $file in
*bin/rm|*bin/busybox|*bin/rsync|/etc/*) ;;
*) rm -f "$KISS_ROOT/$file" ;;
esac
2019-08-13 09:21:03 +00:00
# Remove directories if empty.
[ -d "$KISS_ROOT/$file" ] && rmdir "$file" 2>/dev/null ||:
2019-08-04 09:39:21 +00:00
done ||:
2019-07-22 16:01:31 +00:00
}
2019-06-29 20:38:35 +00:00
2019-07-22 08:01:37 +00:00
# Install the package again to fix any non-leftover files being
# removed above.
2019-08-04 09:39:21 +00:00
rsync_pkg ||:
rsync_pkg ||:
2019-07-22 08:01:37 +00:00
# Reset 'trap' to its original value. Installation is done so
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-06-29 20:38:35 +00:00
# Run the post install script and suppress errors. If it exists,
# it will run, else nothing will happen.
2019-08-15 16:02:00 +00:00
[ -x "$KISS_ROOT/$pkg_db/$pkg_name/post-install" ] && {
2019-08-19 18:02:18 +00:00
log "[$pkg_name] Running post-install script"
2019-08-15 16:02:41 +00:00
"$KISS_ROOT/$pkg_db/$pkg_name/post-install" ||:
2019-08-15 16:02:00 +00:00
}
2019-06-29 20:38:35 +00:00
2019-08-19 18:02:18 +00:00
log "[$pkg_name] Installed successfully"
2019-06-13 14:48:08 +00:00
done
}
2019-06-29 20:38:35 +00:00
pkg_updates() {
# Check all installed packages for updates. So long as the installed
# version and the version in the repositories differ, it's considered
# an update.
2019-08-19 17:15:50 +00:00
log "Updating repositories"
# Create a list of all repositories.
IFS=:; set -- $KISS_PATH; IFS=$old_ifs
# Update each repository in '$KISS_PATH'. It is assumed that
# each repository is 'git' tracked.
for repo; do
2019-08-14 09:58:14 +00:00
cd "$repo"
# Go to the root of the repository (if it exists).
cd "$(git rev-parse --show-toplevel 2>/dev/null)" 2>/dev/null ||:
[ -d .git ] || {
2019-08-19 18:02:18 +00:00
log "[$repo] Not a git repository, skipping"
2019-08-14 09:58:14 +00:00
continue
}
case $repos in
# If the repository has already been updated, skip it.
*" $PWD "*) ;;
*)
repos="$repos $PWD "
2019-08-19 18:02:18 +00:00
log "[$PWD] Updating repository"
2019-08-14 09:58:14 +00:00
if [ -w "$PWD" ]; then
git pull
else
2019-08-19 18:02:18 +00:00
log "[$PWD] Need root to update"
2019-08-14 09:58:14 +00:00
sudo git pull
fi
;;
esac
done
2019-08-19 17:15:50 +00:00
log "Checking for new package versions"
# Enable globbing.
set +f
2019-07-19 22:14:46 +00:00
for pkg in "$KISS_ROOT/$pkg_db/"*; do
2019-06-29 20:38:35 +00:00
# Find the package's repository files. This needs to keep
# happening as we can't store this data in any kind of data
# structure.
repo_dir=$(pkg_search "${pkg##*/}")
# Read version and release information from the installed packages
# and repository.
read -r db_ver db_rel < "$pkg/version"
read -r re_ver re_rel < "$repo_dir/version"
# Compare installed packages to repository packages.
2019-07-11 06:14:17 +00:00
[ "$db_ver-$db_rel" != "$re_ver-$re_rel" ] && {
printf '%s\n' "${pkg##*/} $db_ver-$db_rel ==> $re_ver-$re_rel"
2019-07-11 06:14:17 +00:00
outdated="$outdated${pkg##*/} "
}
2019-06-13 14:48:08 +00:00
done
2019-07-11 06:14:17 +00:00
# Disable globbing.
set -f
2019-07-11 06:14:17 +00:00
# End here if no packages have an update.
[ "$outdated" ] || {
2019-08-19 17:15:50 +00:00
log "Everything is up to date"
2019-07-11 06:14:17 +00:00
return
}
# Turn the string of outdated packages into a 'list'.
set -- $outdated
2019-07-11 06:14:17 +00:00
2019-08-19 17:15:50 +00:00
log "Packages to update: $*"
# Tell 'pkg_build' to always prompt before build.
2019-07-13 22:18:07 +00:00
build_prompt=1
2019-07-11 06:14:17 +00:00
2019-07-26 16:56:22 +00:00
# Build all packages requiring an update.
pkg_build "$@"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_clean() {
# Clean up on exit or error. This removes everything related
# to the build.
2019-08-01 16:31:27 +00:00
[ "$KISS_DEBUG" = 1 ] && return
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
# Remove temporary directories.
rm -rf -- "$mak_dir" "$pkg_dir" "$tar_dir"
2019-06-13 14:48:08 +00:00
# Remove temporary files.
2019-08-15 15:28:46 +00:00
set +f; rm -f "$cac_dir/c-"* "$cac_dir/m-"*
2019-06-29 20:38:35 +00:00
}
2019-06-15 06:19:20 +00:00
2019-06-29 20:38:35 +00:00
args() {
# Parse script arguments manually. POSIX 'sh' has no 'getopts'
# or equivalent built in. This is rather easy to do in our case
# since the first argument is always an "action" and the arguments
# that follow are all package names.
# Actions can be abbreviated to their first letter. This saves
# keystrokes once you memorize the commands and it also has the
# side-effect of "correcting" spelling mistakes (assuming the first
# letter is right).
2019-06-29 20:38:35 +00:00
case $1 in
# Build the list of packages.
2019-07-24 22:25:40 +00:00
b|bu|bui|buil|build)
2019-06-29 20:38:35 +00:00
shift
# If no arguments were passed, rebuild all packages.
[ "$1" ] || {
2019-08-19 17:15:50 +00:00
cd "$KISS_ROOT/$pkg_db" || die "Failed to find package db"
2019-07-13 22:18:07 +00:00
# Use a glob after 'cd' to generate a list of all installed
# packages based on directory names.
set +f; set -f -- *
2019-07-13 22:18:07 +00:00
# Undo the above 'cd' to ensure we stay in the same location.
cd - >/dev/null
}
2019-06-29 20:38:35 +00:00
pkg_build "$@"
;;
# Generate checksums for packages.
2019-07-24 22:25:40 +00:00
c|ch|che|chec|check|checks|checksu|checksum|checksums)
2019-06-29 20:38:35 +00:00
shift
2019-08-19 17:15:50 +00:00
[ "$1" ] || die "'kiss checksum' requires an argument"
2019-06-29 20:38:35 +00:00
for pkg; do pkg_lint "$pkg"; done
for pkg; do pkg_sources "$pkg"; done
2019-07-21 11:21:47 +00:00
for pkg; do
pkg_checksums "$pkg" > "$(pkg_search "$pkg")/checksums"
2019-06-29 20:38:35 +00:00
2019-08-19 18:02:18 +00:00
log "[$pkg] Generated checksums"
2019-07-21 11:21:47 +00:00
done
2019-06-29 20:38:35 +00:00
;;
# Install packages.
2019-07-24 22:25:40 +00:00
i|in|ins|inst|insta|instal|install)
2019-06-29 20:38:35 +00:00
shift
2019-08-19 17:15:50 +00:00
[ "$1" ] || die "'kiss install' requires an argument"
2019-08-12 23:57:31 +00:00
# Rerun the script with 'sudo' if the user isn't root.
# Cheeky but 'sudo' can't be used on shell functions
# themselves.
[ "$(id -u)" != 0 ] && {
sudo KISS_PATH=$KISS_PATH kiss i "$@"
return
}
# Create a list of each package's dependencies.
2019-08-05 06:11:02 +00:00
for pkg; do
if [ "${pkg%%*.tar.gz}" ]; then
pkg_depends "$pkg"
else
missing_deps="$missing_deps $pkg "
fi
done
# Filter the list, only including explicit packages.
for pkg in $missing_deps; do
case " $* " in
*" $pkg "*) install_pkgs="$install_pkgs $pkg " ;;
esac
done
set -- $install_pkgs
2019-06-29 20:38:35 +00:00
pkg_install "$@"
;;
# Remove packages.
2019-07-24 22:25:40 +00:00
r|re|rem|remo|remov|remove)
2019-06-29 20:38:35 +00:00
shift
2019-08-19 17:15:50 +00:00
[ "$1" ] || die "'kiss remove' requires an argument"
2019-08-12 23:57:31 +00:00
# Rerun the script with 'sudo' if the user isn't root.
# Cheeky but 'sudo' can't be used on shell functions
# themselves.
[ "$(id -u)" != 0 ] && {
sudo KISS_PATH=$KISS_PATH kiss r "$@"
return
}
2019-08-19 17:15:50 +00:00
log "Removing packages"
# Create a list of each package's dependencies.
for pkg; do pkg_depends "$pkg"; done
# Reverse the list of dependencies filtering out anything
# not explicitly set for removal.
for pkg in $missing_deps; do
case " $* " in
*" $pkg "*) remove_pkgs="$pkg $remove_pkgs" ;;
esac
done
for pkg in $remove_pkgs; do
pkg_list "$pkg" >/dev/null ||
2019-08-19 18:02:18 +00:00
die "[$pkg] Not installed"
pkg_remove "$pkg" check
done
2019-06-29 20:38:35 +00:00
;;
# List installed packages.
2019-07-24 22:25:40 +00:00
l|li|lis|list)
2019-06-29 20:38:35 +00:00
shift
pkg_list "$@"
;;
# Upgrade packages.
2019-08-14 10:24:58 +00:00
u|up|upd|upda|updat|update)
2019-06-29 20:38:35 +00:00
pkg_updates
;;
2019-07-23 23:45:20 +00:00
# Search for packages.
2019-07-24 22:25:40 +00:00
s|se|sea|sear|searc|search)
shift
2019-08-19 17:15:50 +00:00
[ "$1" ] || die "'kiss search' requires an argument"
2019-07-23 23:45:20 +00:00
for pkg; do
# Create a list of all matching packages.
set -- $(IFS=:; find $KISS_PATH -mindepth 1 \
-maxdepth 1 -name "$pkg")
# Print all matches. If there aren't any, print an error.
2019-08-19 17:15:50 +00:00
printf '%s\n' "${@:-$(log "[$pkg] Not found")}"
2019-07-23 23:45:20 +00:00
# Exit with an error if a search fails.
[ "$1" ] || exit 1
done
2019-07-13 20:31:00 +00:00
;;
2019-06-29 20:38:35 +00:00
# Print version and exit.
2019-07-24 22:25:40 +00:00
v|ve|ver|vers|versi|versio|version)
2019-08-19 18:12:42 +00:00
printf 'kiss 0.7.0\n'
2019-06-29 20:38:35 +00:00
;;
2019-07-24 22:33:12 +00:00
# Print usage and exit.
2019-07-26 16:22:46 +00:00
h|he|hel|help|-h|--help|'')
2019-08-13 09:21:03 +00:00
log "kiss [b|c|i|l|r|s|u] [pkg] [pkg] [pkg]" \
2019-08-19 17:15:50 +00:00
"build: Build a package" \
"checksum: Generate checksums" \
"install: Install a package" \
"list: List installed packages" \
"remove: Remove a package" \
"search: Search for a package" \
"update: Check for updates"
2019-06-29 20:38:35 +00:00
;;
2019-07-24 22:33:12 +00:00
# Print message about invalid commands.
*)
2019-08-19 17:15:50 +00:00
die "'kiss $1' is not a valid command"
2019-07-24 22:33:12 +00:00
;;
2019-06-13 14:48:08 +00:00
esac
}
main() {
2019-07-19 14:37:25 +00:00
# Set the location to the repository and package database.
2019-07-19 22:14:46 +00:00
pkg_db=var/db/kiss/installed
2019-07-19 14:37:25 +00:00
2019-06-29 20:38:35 +00:00
# The PID of the current shell process is used to isolate directories
# to each specific KISS instance. This allows multiple package manager
# instances to be run at once. Store the value in another variable so
# that it doesn't change beneath us.
pid=$$
2019-06-13 15:11:59 +00:00
# Store the original value of IFS so we can revert back to it if the
# variable is ever changed.
old_ifs=$IFS
2019-06-29 20:38:35 +00:00
# Catch errors and ensure that build files and directories are cleaned
# up before we die. This occurs on 'Ctrl+C' as well as success and error.
2019-06-29 20:38:35 +00:00
trap pkg_clean EXIT INT
2019-06-13 14:48:08 +00:00
2019-07-03 13:35:14 +00:00
# Create the required temporary directories and set the variables
# which point to them.
2019-07-21 10:10:51 +00:00
mkdir -p "${cac_dir:=$KISS_ROOT/var/cache/kiss}" \
"${mak_dir:=$cac_dir/build-$pid}" \
"${pkg_dir:=$cac_dir/pkg-$pid}" \
"${tar_dir:=$cac_dir/extract-$pid}" \
"${src_dir:=$cac_dir/sources}" \
"${bin_dir:=$cac_dir/bin}" \
2019-08-19 17:15:50 +00:00
|| die "Couldn't create cache directories"
2019-07-03 13:35:14 +00:00
2019-06-13 14:48:08 +00:00
args "$@"
}
main "$@"